package App::Cmd::CommandRole::UTF8;
$App::Cmd::CommandRole::UTF8::VERSION = '0.01';
use Role::Tiny;
use Encode;

around [qw(abstract description)] => sub {
    my ($orig, $self) = (shift, shift);
    my $str = $self->$orig(@_);
    utf8::is_utf8($str) ? encode_utf8 $str : $str;
};

1;

__END__

=encoding utf8

=head1 NAME

App::Cmd::CommandRole::UTF8 - Role for methods abstract() and description().

=head1 DESCRIPTION

If the return value is utf8 flagged, it will encode_utf8.

    around [qw(abstract description)] => sub {
        my ($orig, $self) = (shift, shift);
        my $str = $self->$orig(@_);
        utf8::is_utf8($str) ? encode_utf8 $str : $str;
    };
